"""
 -*-coding:utf-8 -*-
----------------------------------------------------------------------------
--ProjectName:   pytest
--FileName:      test_bpm.py
--Author:        Lin
--Datetime:      2024/11/05 下午7:11
--Description:   主程序，请运行这个
-----------------(❁´◡`❁)---------------------------------------------------
"""
import pytest
import allure

from APIAutomaticTesting import log, logor
from APIAutomaticTesting.common.read_excel import ReadExcel
from APIAutomaticTesting.test_case.test_Kumiko import USERNAME


class TestBPM:
    @allure.epic("BPM_Kumiko")
    @pytest.mark.parametrize("method, url, mime, case_data, expect_data, sql_type, sql_data, update_key, module, api, title, level", ReadExcel(USERNAME).get_data())
    def test_bpm(self, req_fix, method, url, mime, case_data, expect_data, sql_type, sql_data, update_key, module, api, title, level):
        allure.dynamic.feature(module) # 用例模块
        allure.dynamic.story(api) # 用例接口
        allure.dynamic.title(title) # 用例标题
        allure.dynamic.severity(level) # 级别

        # 使用RequestsMethod类对象调用request_all方法发送请求。自定义固件就是RequestsMethod类对象
        res = req_fix.request_all(req_method=method, req_url=url, req_mime=mime, req_case_data=case_data, sql_type=sql_type, sql_data=sql_data, update_key=update_key)

        # 断言
        try:
            for key in expect_data.keys():
                assert res.json().get(key) == expect_data[key]
        except AssertionError:
            log.error(f"断言失败，用例数据为：{case_data}，期望数据为：{expect_data}， 服务器返回的数据为：{res.text}")
            raise AssertionError("断言失败")
        else:
            log.info(f"断言成功，用例数据为：{case_data}，期望数据为：{expect_data}， 服务器返回的数据为：{res.text}")